	list		p=12F1840
	#include	<p12F1840.inc>

  ;  __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
   ; __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_ON & _CLKOUTEN_OFF & _IESO_ON & _FCMEN_ON
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_ON & _BORV_LO & _LVP_ON
  	





	CBLOCK		20h
		N1	
		N10		
		N100			
		ADRESA_EEPROM
		HODNOTA_EEPROM
		TMP_RS232
		count_rs232
		PAUZA_RS232
		RX_N1
		RX_N2
		RX_N3
	ENDC


	#define		RX_UART			PORTA,5
	#define		TX_UART			PORTA,2

; Oscilator 32 MHz
;	#define		Baud_rs232				.184 ;.174 - 193 = 14400 baud
;	#define		Baud_rs232				.135 ;.128 - 141 = 19200 baud
;	#define		Baud_rs232				.65 ; .62 - 68 = 38400 baud	
;	#define		Baud_rs232				.42 ; .40 - 44 = 57600 baud
;	#define		Baud_rs232				.19 ; .18 - 20 = 115200 baud
;	#define		Baud_rs232				.16 ; .16 - 17 = 128000 baud
;	#define		Baud_rs232				.6 ; 		   = 256000 baud

; Oscilator 8 MHz
;	#define		Baud_rs232				.30 ; = 19200 baud


; Oscilator 4 MHz
;	#define		Baud_rs232				.183 ; .175 - .190 = 1800 baud
;	#define		Baud_rs232				.135 ; .130 - .140 = 2400 baud
	#define		Baud_rs232				.30 ;.31 ;.28-.33 = 9600 baud
;	#define		Baud_rs232				.13; .12-.14 = 19200 baud
;	#define		Baud_rs232				.5; .4-.5 = 38400 baud


; Oscilator 31 kHz
;	#define		Baud_rs232				.2 ; = 150 baud
;	#define		Baud_rs232				.5 ; = 300 baud
; Oscilator 125 kHz
;	#define		Baud_rs232				.31 ;.30 - 32= 300 baud

		
;***************************************************************************************************************************
	org		00h
	GOTO	START	
;***************************************************************************************************************************
	org		004h
	goto 	prerusenie
;***************************************************************************************************************************


nastavenie_PIC						;-----u-----;
				   ;		   	  + ; Vdd	Vss ; -
				   ; 	RX_UART		; RA5	RA0 ; PGD
				   ; 				; RA4	RA1 ; PGC
				   ;			Vpp ; RA3	RA2 ; 		TX_UART 
									;-----------;

		banksel PORTA 		;--------------------------------- bank 0 ----------------------------------------------------
		clrf 	PORTA 
;		movlw	b'00000000'	; bit7 GIE: 1=global interrupt ;bit6 PEIE: 1=peripheral interrupt
		movlw	b'10001000'	; bit7 GIE: 1=global interrupt ;bit6 PEIE: 1=peripheral interrupt
		movwf	INTCON
		banksel	LATA 		;--------------------------------- bank 2 ----------------------------------------------------
		clrf 	LATA 
		banksel ANSELA		;--------------------------------- bank 3 ----------------------------------------------------
		clrf 	ANSELA

		banksel TRISA		;--------------------------------- bank 1 ----------------------------------------------------
		movlw 	b'00100000' 
		movwf 	TRISA 
	;	movlw	b'00000010'		; bit7 zapnutie 4xPLL; bity6-3 frekvencia (31 kHz)
	;	movlw	b'00101010'		; bit7 zapnutie 4xPLL; bity6-3 frekvencia (125 kHz)
		movlw	b'01101010'		; bit7 zapnutie 4xPLL; bity6-3 frekvencia (4 MHz)
		;movlw	b'01101000'		; bit7 = 4xPLL; bity6-3:
								;	000x = 31 kHz LF
								;	0010 = 31.25 kHz MF
								;	0011 = 31.25 kHz HF(1)
								;	0100 = 62.5 kHz MF
								;	0101 = 125 kHz MF
								;	0110 = 250 kHz MF
								;	0111 = 500 kHz MF (default upon Reset)
								;	1000 = 125 kHz HF(1)
								;	1001 = 250 kHz HF(1)
								;	1010 = 500 kHz HF(1)
								;	1011 = 1MHz HF
								;	1100 = 2MHz HF
								;	1101 = 4MHz HF
								;	1110 = 8 MHz or 32 MHz HF(see Section 5.2.2.1 HFINTOSC)
								;	1111 = 16 MHz HF
		;movlw	b'11110000'		; bit7 zapnutie 4xPLL; bity6-3 frekvencia (32 MHz)
		movwf	OSCCON					
		;movlw	b'00100101'		;256s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00100011'		;128s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00100001'		;64s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011111'		;32s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011101'		;16s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011011'		;8s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00011001'		;4s bit 5-1 prescale; bit 0 on/off
		movlw	b'00010110'		;2s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010101'		;1s bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010011'		;512ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00010001'		;256ms 5-1 prescale; bit 0 on/off
		;movlw	b'00001111'		;128ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001101'		;64ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001011'		;32ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00001001'		;16ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000111'		;8ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000101'		;4ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000011'		;2ms bit 5-1 prescale; bit 0 on/off
		;movlw	b'00000001'		;1ms bit 5-1 prescale; bit 0 on/off
		movwf	WDTCON			; nastavenie WATCHDOG

		banksel OPTION_REG	;--------------------------------- bank  ----------------------------------------------------
		movlw	b'00000000'
		movwf	OPTION_REG

;		banksel  WPUA		;--------------------------------- bank  ----------------------------------------------------

;		movlw	b'00111010'
;		movwf	WPUA

		banksel  IOCAN		;--------------------------------- bank  ----------------------------------------------------

		movlw	b'00100000'
		movwf	IOCAN

		banksel PORTA		;--------------------------------- bank 0 ----------------------------------------------------
		clrf	PORTA
		clrf	LATA
		call	vycistenie_GPR_banky_0
	return







vycistenie_GPR_banky_0
		movlw	.80				; 80 bajtov GPR v kazdej banke
		movwf	020h
		clrf	FSR0H
		movlw	020h+1 			; druhy bajt GPR banky 0 (prvy bajt je pocitadlo)
		movwf	FSR0L
	opakuj_nulovanie_bajtov_0
		movlw	.0
		movwf	INDF0
		incf	FSR0L,f
		decfsz	020h,f
		goto	opakuj_nulovanie_bajtov_0
		clrf	020h
	return





;***********************************************************************************************
;*************************************** PAUZY *************************************************
;***********************************************************************************************


pauza		
		movwf	N100

p10		movlw	.100
		movwf	N10

p1		movlw	.10
		movwf	N1
		decfsz	N1
		goto	$-1

		decfsz	N10
		goto	p1

		decfsz	N100
		goto	p10
	return			





pauza31		
		movwf	N100

pp10		movlw	.10
		movwf	N10

pp1		movlw	.3
		movwf	N1
		decfsz	N1
		goto	$-1

		decfsz	N10
		goto	pp1

		decfsz	N100
		goto	pp10
	return			




;***********************************************************************************************
;*************************************** ZAPIS/CITANIE EEPROM ****************************************
;***********************************************************************************************


	;******************************* zapis EEPROM *******************************
WRITE_EPROM
		movwf	HODNOTA_EEPROM
		banksel	EECON1
		btfsc	EECON1,WR		
		goto	$-1		
		banksel	PORTA
		movf	ADRESA_EEPROM,w				 
		banksel	EEADRL			
		movwf	EEADRL			
		banksel	PORTA			
		movf	HODNOTA_EEPROM,w				
		banksel	EEDATL		 
		movwf	EEDATL		
		banksel	EECON1
		bcf		EECON1, CFGS 
		bcf 	EECON1, EEPGD 
		bsf 	EECON1, WREN 
		bcf 	INTCON, GIE  
		movlw	0x55	
		movwf	EECON2	
		movlw	0xAA	 
		movwf	EECON2	
		bsf 	EECON1, WR 
		bsf 	INTCON, GIE 
		bcf 	EECON1, WREN 
		btfsc 	EECON1, WR 
		GOTO 	$-2
		banksel	PORTA
	return


	;******************************* citanie z EEPROM *******************************
READ_EPROM
		movwf	ADRESA_EEPROM
		banksel	EEADRL
		movwf	EEADRL
		bcf 	EECON1, CFGS 
		bcf 	EECON1, EEPGD
		bsf 	EECON1, RD 
		movf 	EEDATL, W
		banksel	PORTA
	return







;**************************************************************************************************
;********************************* Softverovy USART RS232 ******************************************
;**************************************************************************************************


cakaj_uart_bit				
		movlw	Baud_rs232	
		movwf	PAUZA_RS232	
		decfsz	PAUZA_RS232,f
		goto	$-1	
	return
		


cakaj_uart_polbit				
		movlw	Baud_rs232/3
		movwf	PAUZA_RS232	
		decfsz	PAUZA_RS232,f
		goto	$-1	
	return
		


USART_TXW
			;z W registra vloz hodnotu na vysielanie
		movwf	TMP_RS232
			;nastav pocitadlo na vyslanie 8 datovych bitov
		movlw	.8
		movwf	count_rs232	
			;vyslanie STOP bitu
		bsf		TX_UART
		call	cakaj_uart_bit	
;		call	cakaj_uart_bit	
			;vyslanie START bitu
		bcf		TX_UART
		call	cakaj_uart_bit
scitx1
				;vysielanie datovych bitov 
			rrf		TMP_RS232,f
			btfsc	STATUS,C
			bsf		TX_UART			
			btfss	STATUS,C
			bcf		TX_UART	
			call	cakaj_uart_bit
			;opakuj 8 bitov
		decfsz	count_rs232,f
		goto	scitx1	
			;vyslanie STOP bitu
		bsf		TX_UART				
		call	cakaj_uart_bit	
		call	cakaj_uart_bit	
	return




USART_RXW	
		clrf	TMP_RS232
		movlw	.8
		movwf	count_rs232	
			;testuj v slucke START bit
		btfsc	RX_UART		;Cakaj na START bit. (spad do urovne LOW)						
		goto	$-1	
			;cakaj dlzku start bitu
		call	cakaj_uart_bit	
			;cakaj na prechod na stred prveho bitu (aby bola istota vo vyhodnocovani)
		call	cakaj_uart_polbit	
scirx2	
				;testuj uprostred stav datoveho bitu (0,1)
			btfsc	RX_UART						
			bsf		STATUS,C	
			btfss	RX_UART
			bcf		STATUS,C	
				;ukladaj stav jednotlivych bitov do registra
			rrf		TMP_RS232,f	
				;cakaj na prechod na stred dalsieho bitu
			call	cakaj_uart_bit	
			;opakuj proces 8x (8 bitov)
		decfsz	count_rs232,f				
		goto	scirx2
		btfss	RX_UART		;Cakaj na startovnu uroven HIGH STOP bit (z predosleho bajtu) 					
		goto	$-1	
			;Vloz obsah prijatych dat do W registra
		movf	TMP_RS232,w					
	return
	






;**************************************************************************************************
;************************************ OBSLUHA PRERUSENIA ******************************************
;**************************************************************************************************

prerusenie		

		bcf		INTCON,GIE
		bcf		INTCON,IOCIF
		banksel	IOCAF
		btfss	IOCAF,IOCAF5
		goto	preskoc_rx_uart
		banksel	PORTA
			call	USART_RXW	
			movwf	RX_N1
			call	USART_RXW	
			movwf	RX_N2
			call	USART_RXW	
			movwf	RX_N3
		banksel	IOCAF
		bcf		IOCAF,IOCAF5
		preskoc_rx_uart
		banksel	PORTA
		bsf		INTCON,GIE	

	RETFIE




;***********************************************************************************************
;************************************* HLAVNY PROGRAM ******************************************
;***********************************************************************************************


START
		call	nastavenie_PIC	

		bsf		TX_UART

			;Cakanie na bezpecne zapnutie PIC obvodu.
		movlw	.1
		call	pauza


opakuj	


;		movlw	.0
;		movwf	ADRESA_EEPROM
;		movlw	.15
;		call	WRITE_EPROM

bcf		INTCON,GIE
			;Text vysielany s slucke do PC
		movlw	'S'
		call	USART_TXW
		movlw	't'
		call	USART_TXW
		movlw	'l'
		call	USART_TXW
		movlw	'a'
		call	USART_TXW
		movlw	'c'
		call	USART_TXW

		movlw	' '
		call	USART_TXW

		movlw	'T'
		call	USART_TXW
		movlw	'e'
		call	USART_TXW
		movlw	's'
		call	USART_TXW
		movlw	't'
		call	USART_TXW
		movlw	':'
		call	USART_TXW

		movlw	' '
		call	USART_TXW

			;Prijaty text/cisla z PC, ktore sa pripoja na koniec textu vysielaneho do PC v slucke
		movf	RX_N1,w
		call	USART_TXW
		movf	RX_N2,w
		call	USART_TXW
		movf	RX_N3,w
		call	USART_TXW

bsf		INTCON,GIE

;		movlw	.7
;		movlw	.240
		movlw	.20
		call	pauza


	goto 	opakuj

	END
